\section{Style transfer using ResNet50}
\subsection{Introduction to the ResNet50}
In short, the ResNet50 CNN \cite{ResNet50} is a popular network based on the
concept of building deeper neural networks without a degradation in accuracy.
It’s working principle (illustrated in \autoref{fig:resnet50-diagram}) is to
feedforward identity skip connections within blocks of layers (called residual
blocks). In the learning process, the residual block will try to learn the true
output $H(x) = F(x) + x$, subsequently each layer will try to learn the
residual $F(x) = H(x)-x$. This will prevent vanishing gradients, (changing the
weights due to extremely small gradient values).

\begin{figure}
    \centering
    \includegraphics[width=0.3\textwidth]{appendices/resnet50-diagram.png}
    \caption{ResNet50 working principle}
    \label{fig:resnet50-diagram}
\end{figure}
 
\subsection{Implementation and code}
The first step in the implementation of the network is to understand the
underlying architecture in the Keras ResNet50 model. The network is divided
into six main blocks, each one containing various residual blocks with
convolutional, batch normalization, and ReLu layers, followed by an addition
and activation layer. Between each main block, the skipped connection needs to
handle the dimension increase, therefore, instead of being the identity, it
will perform a different convolution to the initial result.

After overviewing the architecture, the model needs to be changed by replacing
the VGG19 for the ResNet and the loss weights adapted. One can find the
original tutorial adapted to run with ResNet50 in
\href{https://colab.research.google.com/drive/1Wr8BDEWu_ELFdbEkWRXbacTHgmvLSjLu?usp=sharing}{a
Google Colab notebook}.

\subsection{Experiments}
Random layers were selected twice for the test, in an attempt to select deep
layers for higher level features. The results gave outputs with a worse visual
composition than with the VGG19 architecture, as seen in
\autoref{fig:resnet50-result} and further experimentation with ResNet50 was not
carried out in favour of extending the experiments with VGG19.

\begin{figure}
    \centering
    \begin{subfigure}{0.3\textwidth}
        \centering
        \includegraphics[width=\textwidth]{appendices/resnet50-result.jpeg}
    \end{subfigure}
    \begin{subfigure}{0.3\textwidth}
        \centering
        \includegraphics[width=\textwidth]{appendices/resnet50-result2.jpeg}
    \end{subfigure}
    \begin{subfigure}{0.3\textwidth}
        \centering
        \includegraphics[width=\textwidth]{appendices/resnet50-result3.jpeg}
    \end{subfigure}
    \caption{Sample of ResNet50 first style transfer outputs}
    \label{fig:resnet50-result}
\end{figure}
